Bug 1108192 - Include all LAPACKE routines
Summary: Include all LAPACKE routines
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: lapack
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tom "spot" Callaway
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1043083
TreeView+ depends on / blocked
 
Reported: 2014-06-11 14:33 UTC by Susi Lehtola
Modified: 2014-07-17 04:33 UTC (History)
4 users (show)

Fixed In Version: lapack-3.4.2-7.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-07-17 04:30:47 UTC


Attachments (Terms of Use)

Description Susi Lehtola 2014-06-11 14:33:52 UTC
I'm trying to update OpenBLAS to 0.2.9, but it needs LAPACKE routines that aren't yet packaged.

/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2504: undefined reference to `LAPACKE_clatms'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2505: undefined reference to `LAPACKE_clatms_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2506: undefined reference to `LAPACKE_dlatms'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2507: undefined reference to `LAPACKE_dlatms_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2508: undefined reference to `LAPACKE_slatms'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2509: undefined reference to `LAPACKE_slatms_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2510: undefined reference to `LAPACKE_zlatms'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2511: undefined reference to `LAPACKE_zlatms_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2512: undefined reference to `LAPACKE_clagge'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2513: undefined reference to `LAPACKE_clagge_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2514: undefined reference to `LAPACKE_dlagge'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2515: undefined reference to `LAPACKE_dlagge_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2516: undefined reference to `LAPACKE_slagge'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2517: undefined reference to `LAPACKE_slagge_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2518: undefined reference to `LAPACKE_zlagge'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2519: undefined reference to `LAPACKE_zlagge_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2520: undefined reference to `LAPACKE_claghe'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2521: undefined reference to `LAPACKE_claghe_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2522: undefined reference to `LAPACKE_zlaghe'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2523: undefined reference to `LAPACKE_zlaghe_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2524: undefined reference to `LAPACKE_clagsy'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2525: undefined reference to `LAPACKE_clagsy_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2526: undefined reference to `LAPACKE_dlagsy'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2527: undefined reference to `LAPACKE_dlagsy_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2528: undefined reference to `LAPACKE_slagsy'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2529: undefined reference to `LAPACKE_slagsy_work'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2530: undefined reference to `LAPACKE_zlagsy'
/builddir/build/BUILD/openblas-0.2.9/serial/exports/linktest.c:2531: undefined reference to `LAPACKE_zlagsy_work'

Looks like these are in MATGEN_OBJ. Could you include these in the lapacke library as well?

Comment 1 Susi Lehtola 2014-06-15 15:22:36 UTC
Or, since these are related to the link test, you could ship the extra objects in another library.

Comment 2 Tom "spot" Callaway 2014-06-17 17:26:58 UTC
Do you only need this in rawhide?

Comment 3 Milan Bouchet-Valat 2014-06-17 18:02:09 UTC
As OpenBLAS 0.2.9 fixes a few serious bugs, it would be nice to also have this in F20 IMHO.

Comment 4 Susi Lehtola 2014-06-17 18:16:06 UTC
(In reply to Milan Bouchet-Valat from comment #3)
> As OpenBLAS 0.2.9 fixes a few serious bugs, it would be nice to also have
> this in F20 IMHO.

Indeed. And it shouldn't be a problem to update LAPACK in F20 either, since it's just a bugfix update...

Comment 5 Tom "spot" Callaway 2014-06-17 18:51:45 UTC
Yup. I'm not going to push 3.5.0 into f20, but this fix is applicable to 3.4.2 as well.

Comment 6 Susi Lehtola 2014-06-17 19:40:28 UTC
Well, there are some lapacke routines that are missing from 3.4.2, so I'm not sure if it's enough.

The thing is, openblas 0.2.8 has lapacke support compiled in, and pushing to 0.2.9 with all of its important bugfixes would probably require lapack 3.5.0.

Which is why I wanted an exception from the FPC in the first place..

Comment 7 Fedora Update System 2014-06-17 20:00:17 UTC
lapack-3.4.2-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lapack-3.4.2-4.fc20

Comment 8 Susi Lehtola 2014-06-17 20:36:54 UTC
OK, looks like this fixes the link problem. Thanks.

Comment 9 Susi Lehtola 2014-06-18 07:53:47 UTC
Looks like I spoke too soon. Now I get

gcc -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches  -m64 -mtune=generic -Wall -m64 -DF_INTERFACE_GFORT  -fPIC  -DDYNAMIC_ARCH -DNO_WARMUP -DMAX_CPU_NUMBER=128 -DASMNAME= -DASMFNAME=_ -DNAME=_ -DCNAME= -DCHAR_NAME=\"_\" -DCHAR_CNAME=\"\" -DNO_AFFINITY -I..  -w -o linktest linktest.c ../libopenblas-r0.2.9.so -L/usr/lib/gcc/x86_64-redhat-linux/4.8.2 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.2/../../../../lib64 -L/lib/../lib64 -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-redhat-linux/4.8.2/../../..  -lgfortran -lm -lquadmath -lm -lc   && echo OK.
../libopenblas-r0.2.9.so: undefined reference to `clagge_'
../libopenblas-r0.2.9.so: undefined reference to `clatms_'
../libopenblas-r0.2.9.so: undefined reference to `dlagsy_'
../libopenblas-r0.2.9.so: undefined reference to `slatms_'
../libopenblas-r0.2.9.so: undefined reference to `zlatms_'
../libopenblas-r0.2.9.so: undefined reference to `slagsy_'
../libopenblas-r0.2.9.so: undefined reference to `dlagge_'
../libopenblas-r0.2.9.so: undefined reference to `clagsy_'
../libopenblas-r0.2.9.so: undefined reference to `make[1]: Leaving directory `/builddir/build/BUILD/openblas-0.2.9/serial/exports'
claghe_'
../libopenblas-r0.2.9.so: undefined reference to `zlagsy_'
../libopenblas-r0.2.9.so: undefined reference to `slagge_'
../libopenblas-r0.2.9.so: undefined reference to `zlagge_'
../libopenblas-r0.2.9.so: undefined reference to `dlatms_'
../libopenblas-r0.2.9.so: undefined reference to `zlaghe_'
collect2: error: ld returned 1 exit status

so these routines would need to be added to the LAPACK library; they reside in the TESTING directory.

Comment 10 Fedora Update System 2014-06-18 22:21:20 UTC
Package lapack-3.4.2-4.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing lapack-3.4.2-4.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-7472/lapack-3.4.2-4.fc20
then log in and leave karma (feedback).

Comment 11 Fedora Update System 2014-06-19 03:26:34 UTC
lapack-3.4.2-5.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lapack-3.4.2-5.fc20

Comment 12 Susi Lehtola 2014-06-19 07:09:08 UTC
OK, now the necessary object files seem to have been compiled, but they are in a static archive inside a static archive

+ /usr/lib/rpm/redhat/brp-strip-static-archive /usr/bin/strip
/usr/bin/strip:/home/lehtolj5/rpmbuild/BUILDROOT/lapack-3.4.2-5.fc20.x86_64/usr/lib64/liblapacke.a(libtmglib.a): Unable to recognise the format of file: File format not recognized

what is probably what you didn't intend...

Comment 13 Fedora Update System 2014-06-20 05:07:51 UTC
lapack-3.4.2-6.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lapack-3.4.2-6.fc20

Comment 14 Fedora Update System 2014-07-08 13:34:50 UTC
lapack-3.4.2-7.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lapack-3.4.2-7.fc20

Comment 15 Fedora Update System 2014-07-08 13:34:59 UTC
lapack-3.4.2-7.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/lapack-3.4.2-7.fc19

Comment 16 Fedora Update System 2014-07-17 04:30:47 UTC
lapack-3.4.2-7.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2014-07-17 04:33:08 UTC
lapack-3.4.2-7.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.